#include <bits/stdc++.h>
using namespace std;
int n,q,niz[200005],a,b,prefiks[200005],prefiks2[200005],prefiksDvojki[200005];
bool sJiD=true;
int main(){
  scanf("%d",&n);
  for(int i=1; i<=n; i++){
    scanf("%d",&niz[i]);
    if(niz[i]>2)sJiD=false;
    if(niz[i]<niz[i-1])prefiks[i-1]=1;
  }
  if(sJiD){
    for(int i=1; i<=n; i++){
      if(niz[i]==2)prefiksDvojki[i]++;
      if(niz[i]==1 and niz[i-1]==2){
        int br=i+1;
        while(niz[br]==1){
          prefiks[br]=1;
          br++;
        }
      }
    }
      for(int i=1; i<=n; i++){
        prefiks[i]=prefiks[i]+prefiks[i-1];
        prefiks2[i]=prefiks2[i-1]+niz[i];
        prefiksDvojki[i]=prefiksDvojki[i-1]+prefiksDvojki[i];
    }
    scanf("%d",&q);
    for(int i=1; i<=q; i++){
      scanf("%d%d",&a,&b);
      if(prefiks[b]-prefiks[a-1]<=1 or prefiks2[b]-prefiks2[a-1]==b-a+1 or prefiksDvojki[b]-prefiksDvojki[a-1]<=1)cout << "DA\n";
      else cout << "NE\n";
      //cout << prefiks[b-1]-prefiks[a-1] << endl;
    }
  }
  else{
    for(int i=1; i<=n; i++){
      prefiks[i]=prefiks[i]+prefiks[i-1];
      //cout << prefiks[i] << " ";
    }
    //cout << endl;
    scanf("%d",&q);
    for(int i=1; i<=q; i++){
      scanf("%d%d",&a,&b);
      if(prefiks[b-1]-prefiks[a-1]<=1)cout << "DA\n";
      else cout << "NE\n";
      //cout << prefiks[b-1]-prefiks[a-1] << endl;
    }
  }
  return 0;
}